## avro-java 1.8.2

=== lang/c++/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
cmake_minimum_required (VERSION 2.6)

set (CMAKE_LEGACY_CYGWIN_WIN32 0)

if (NOT DEFINED CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS)
    set (CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
endif()

if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt)
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt" AVRO_VERSION)
else (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt)
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/../../share/VERSION.txt"
        AVRO_VERSION)
endif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt)

string(REPLACE "\n" "" AVRO_VERSION  ${AVRO_VERSION})
set (AVRO_VERSION_MAJOR ${AVRO_VERSION})
set (AVRO_VERSION_MINOR "0")

project (Avro-cpp)

if (WIN32 AND NOT CYGWIN AND NOT MSYS)
add_definitions (/EHa)
add_definitions (
    -DBOOST_REGEX_DYN_LINK
    -DBOOST_FILESYSTEM_DYN_LINK
    -DBOOST_SYSTEM_DYN_LINK
    -DBOOST_IOSTREAMS_DYN_LINK
    -DBOOST_PROGRAM_OPTIONS_DYN_LINK
    -DBOOST_ALL_NO_LIB)
endif()

if (CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "-Wall")
    set(CMAKE_CXX_FLAGS_DEBUG "-fstack-protector-all -D_GLIBCXX_DEBUG")
    # Unset _GLIBCXX_DEBUG for avrogencpp.cc because using Boost Program Options
    # leads to linking errors when compiling with _GLIBCXX_DEBUG as described on
    # http://stackoverflow.com/questions/19729036/
    set_source_files_properties(impl/avrogencpp.cc PROPERTIES COMPILE_FLAGS "-U_GLIBCXX_DEBUG")
endif ()


find_package (Boost 1.38 REQUIRED
    COMPONENTS filesystem system program_options iostreams)

add_definitions (${Boost_LIB_DIAGNOSTIC_DEFINITIONS})

include_directories (api ${CMAKE_CURRENT_BINARY_DIR} ${Boost_INCLUDE_DIRS})

set (AVRO_SOURCE_FILES
        impl/Compiler.cc impl/Node.cc
        impl/NodeImpl.cc impl/ResolverSchema.cc impl/Schema.cc
        impl/Types.cc impl/ValidSchema.cc impl/Zigzag.cc
        impl/BinaryEncoder.cc impl/BinaryDecoder.cc
        impl/Stream.cc impl/FileStream.cc
        impl/Generic.cc impl/GenericDatum.cc
        impl/DataFile.cc
        impl/parsing/Symbol.cc
        impl/parsing/ValidatingCodec.cc
        impl/parsing/JsonCodec.cc
        impl/parsing/ResolvingDecoder.cc
        impl/json/JsonIO.cc
        impl/json/JsonDom.cc
        impl/Resolver.cc impl/Validator.cc
        )

add_library (avrocpp SHARED ${AVRO_SOURCE_FILES})

set_property (TARGET avrocpp
    APPEND PROPERTY COMPILE_DEFINITIONS AVRO_DYN_LINK)

add_library (avrocpp_s STATIC ${AVRO_SOURCE_FILES})

set_property (TARGET avrocpp avrocpp_s
    APPEND PROPERTY COMPILE_DEFINITIONS AVRO_SOURCE)

set_target_properties (avrocpp PROPERTIES
    VERSION ${AVRO_VERSION_MAJOR}.${AVRO_VERSION_MINOR})

set_target_properties (avrocpp_s PROPERTIES
    VERSION ${AVRO_VERSION_MAJOR}.${AVRO_VERSION_MINOR})

target_link_libraries (avrocpp ${Boost_LIBRARIES})

add_executable (precompile test/precompile.cc)

target_link_libraries (precompile avrocpp_s ${Boost_LIBRARIES})

macro (gen file ns)
    add_custom_command (OUTPUT ${file}.hh
        COMMAND avrogencpp
            -p -
            -i ${CMAKE_CURRENT_SOURCE_DIR}/jsonschemas/${file}
            -o ${file}.hh -n ${ns} -U
        DEPENDS avrogencpp ${CMAKE_CURRENT_SOURCE_DIR}/jsonschemas/${file})
    add_custom_target (${file}_hh DEPENDS ${file}.hh)
endmacro (gen)

gen (empty_record empty)
gen (bigrecord testgen)
gen (bigrecord_r testgen_r)
gen (bigrecord2 testgen2)
gen (tweet testgen3)
gen (union_array_union uau)
gen (union_map_union umu)
gen (union_conflict uc)
gen (recursive rec)
gen (reuse ru)
gen (circulardep cd)

add_executable (avrogencpp impl/avrogencpp.cc)
target_link_libraries (avrogencpp avrocpp_s ${Boost_LIBRARIES})

enable_testing()

macro (unittest name)
    add_executable (${name} test/${name}.cc)
    target_link_libraries (${name} avrocpp ${Boost_LIBRARIES})
    add_test (NAME ${name} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${name})
endmacro (unittest)

unittest (buffertest)
unittest (unittest)
unittest (SchemaTests)
unittest (LargeSchemaTests)
unittest (CodecTests)
unittest (StreamTests)
unittest (SpecificTests)
unittest (DataFileTests)
unittest (JsonTests)
unittest (AvrogencppTests)
unittest (CompilerTests)

add_dependencies (AvrogencppTests bigrecord_hh bigrecord_r_hh bigrecord2_hh
    tweet_hh
    union_array_union_hh union_map_union_hh union_conflict_hh
    recursive_hh reuse_hh circulardep_hh empty_record_hh)

include (InstallRequiredSystemLibraries)

set (CPACK_PACKAGE_FILE_NAME "avrocpp-${AVRO_VERSION_MAJOR}")

include (CPack)

install (TARGETS avrocpp avrocpp_s
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
    RUNTIME DESTINATION lib)

install (TARGETS avrogencpp RUNTIME DESTINATION bin)

install (DIRECTORY api/ DESTINATION include/avro
    FILES_MATCHING PATTERN *.hh)

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif (NOT CMAKE_BUILD_TYPE)

=== lang/c/tests/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#

macro(add_avro_executable name)
    set(source "${ARGV1}")
    if (NOT source)
        set(source "${name}.c")
    endif (NOT source)
    add_executable(${name} ${source})
    target_link_libraries(${name} avro-static)
endmacro(add_avro_executable)

macro(add_avro_test name)
    add_avro_executable(${name} ${ARGN})
    if (WIN32)
        set(exec_name ${CMAKE_CURRENT_BINARY_DIR}/Debug/${name}.exe)
    else (WIN32)
        set(exec_name ${CMAKE_CURRENT_BINARY_DIR}/${name})
    endif (WIN32)

    add_test(${name}
        ${CMAKE_COMMAND} -E chdir ${AvroC_SOURCE_DIR}/tests
        ${exec_name}
    )
endmacro(add_avro_test)

add_avro_executable(generate_interop_data)
add_avro_executable(performance)
add_avro_executable(test_interop_data)

add_avro_test(test_data_structures)
add_avro_test(test_avro_schema)
add_avro_test(test_avro_schema_names)
add_avro_test(test_avro_values)
add_avro_test(test_avro_968)
add_avro_test(test_avro_984)
add_avro_test(test_avro_1034)
add_avro_test(test_avro_1084)
add_avro_test(test_avro_1087)
add_avro_test(test_avro_1165)
add_avro_test(test_avro_1237)
add_avro_test(test_avro_1238)
add_avro_test(test_avro_1279)
add_avro_test(test_avro_1405)
add_avro_test(test_avro_1572)
add_avro_test(test_avro_data)
add_avro_test(test_refcount)
add_avro_test(test_cpp test_cpp.cpp)
add_avro_test(test_avro_1379)
add_avro_test(test_avro_1691)

## avro-java 1.7.7

=== debian/changelog ===
avro-java (1.7.7-3) unstable; urgency=medium

  * Team upload.
  * Disabled paranamer to work around a regression with Qdox (Closes: #871340)
  * Transition to Maven 3
  * Standards-Version updated to 4.1.0
  * Switch to debhelper level 10

 -- Emmanuel Bourg <ebourg@apache.org>  Thu, 14 Sep 2017 11:50:30 +0200

avro-java (1.7.7-2) unstable; urgency=medium

  * Team upload.

  [ Emmanuel Bourg ]
  * Use a secure Vcs-Git URL
  * Build with the DH sequencer instead of CDBS

  [ Markus Koschany ]
  * Declare compliance with Debian Policy 3.9.8.
  * Build-Depend on ant and fix FTBFS.
    Thanks to Lucas Nussbaum for the report. (Closes: #830456)

 -- Markus Koschany <apo@debian.org>  Mon, 18 Jul 2016 21:47:39 +0200

avro-java (1.7.7-1) unstable; urgency=medium

  * Initial release (Closes: #776654)

 -- Emmanuel Bourg <ebourg@apache.org>  Sat, 31 Jan 2015 23:41:31 +0100

=== debian/control ===

Source: avro-java
Section: java
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Emmanuel Bourg <ebourg@apache.org>
Build-Depends: ant,
               debhelper (>= 10),
               default-jdk,
               junit4,
               libcommons-compress-java,
               libcommons-lang-java,
               libjackson-json-java,
               libjavacc-maven-plugin-java,
               libmaven-bundle-plugin-java,
               libmaven-file-management-java,
               libmaven-plugin-testing-java,
               libmaven-plugin-tools-java (>= 3.2),
               libmaven3-core-java,
               libparanamer-java (>= 2.3),
               libparanamer-maven-plugin-java,
               libslf4j-java,
               libsnappy-java,
               libxz-java,
               maven-debian-helper (>= 1.5),
               thrift-compiler,
               velocity
Standards-Version: 4.1.0
Vcs-Git: https://anonscm.debian.org/git/pkg-java/avro-java.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-java/avro-java.git
Homepage: http://avro.apache.org

Package: libavro-java
Architecture: all
Depends: ${misc:Depends}, libjackson-json-java, libparanamer-java, libsnappy-java, libcommons-compress-java, libxz-java, libslf4j-java
Description: Apache Avro data serialization system
 Apache Avro is a data serialization system providing:
  * Rich data structures.
  * A compact, fast, binary data format.
  * A container file, to store persistent data.
  * Remote procedure call (RPC).
  * Simple integration with dynamic languages. Code generation is not required
    to read or write data files nor to use or implement RPC protocols. Code
    generation as an optional optimization, only worth implementing
    for statically typed languages.
 .
 This package contains the Java API of Apache Avro

Package: libavro-compiler-java
Architecture: all
Depends: ${misc:Depends}, libavro-java, libcommons-lang-java, velocity
Description: Apache Avro compiler for Java
 Apache Avro is a data serialization system providing:
  * Rich data structures.
  * A compact, fast, binary data format.
  * A container file, to store persistent data.
  * Remote procedure call (RPC).
  * Simple integration with dynamic languages. Code generation is not required
    to read or write data files nor to use or implement RPC protocols. Code
    generation as an optional optimization, only worth implementing
    for statically typed languages.
 .
 This package contains the compilers for Avro IDL and Avro specific Java API.

Package: libavro-maven-plugin-java
Architecture: all
Depends: ${misc:Depends}, libavro-compiler-java, libmaven-file-management-java
Description: Apache Avro Maven plugin
 Apache Avro is a data serialization system providing:
  * Rich data structures.
  * A compact, fast, binary data format.
  * A container file, to store persistent data.
  * Remote procedure call (RPC).
  * Simple integration with dynamic languages. Code generation is not required
    to read or write data files nor to use or implement RPC protocols. Code
    generation as an optional optimization, only worth implementing
    for statically typed languages.
 .
 This package contains the Maven plugin for Avro IDL and specific API compilers

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure
	# Regenerate the Java classes from the Thrift file
	thrift -gen java:beans -out lang/java/thrift/src/test/java/ lang/java/thrift/src/test/thrift/test.thrift

get-orig-source:
	uscan --download-current-version --force-download --no-symlink

=== debian/watch ===
version=3
opts="uversionmangle=s/-(alpha|beta|rc)(-)?/~$1$2/" \
  http://svn.apache.org/repos/asf/avro/tags/ release-(\d.*)/ debian debian/orig-tar.sh

## avro-java 1.8.2

=== debian/changelog ===
avro-java (1.8.2-1) unstable; urgency=medium

  * Team upload.
  * Update to upstream v1.8.2,
  * Update watch file to track github,
  * Exclude binary files from source,
  * Update Standards-Version to 4.4.1.
  * Update compat level to 12.
  * Update Vcs to salsa.
  * Update copyright.
  * Install Notice.
  * Add Rules-Requires-Root: no.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 06 Jan 2020 20:07:16 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
 Uploaders: Emmanuel Bourg <ebourg@apache.org>
 Build-Depends: ant,
-               debhelper (>= 10),
+               debhelper-compat (= 12),
                default-jdk,
                junit4,
                libcommons-compress-java,
@@ -24,10 +24,12 @@
                libxz-java,
                maven-debian-helper (>= 1.5),
                thrift-compiler,
-               velocity
-Standards-Version: 4.1.0
-Vcs-Git: https://anonscm.debian.org/git/pkg-java/avro-java.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-java/avro-java.git
+               velocity,
+               libmaven-shade-plugin-java
+Standards-Version: 4.4.1
+Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/java-team/avro-java.git
+Vcs-Browser: https://salsa.debian.org/java-team/avro-java
 Homepage: http://avro.apache.org
 
 Package: libavro-java

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure
	# Regenerate the Java classes from the Thrift file
	thrift -gen java:beans -out lang/java/thrift/src/test/java/ lang/java/thrift/src/test/thrift/test.thrift

override_dh_installdocs:
	dh_installdocs -A NOTICE.txt

=== debian/watch ===
version=4
opts="repack,compression=xz" \
https://github.com/apache/avro/tags .*/release-([\d\.]+).tar.gz
